/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vypocet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import javax.servlet.AsyncContext;
import javax.servlet.AsyncEvent;
import javax.servlet.AsyncListener;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


class Vypocet implements Runnable, AsyncListener 
{
    int a,b;
    AsyncContext ac;
    
    public Vypocet(int a, int b, AsyncContext ac)
    {
        this.a = a;
        this.b = b;
        this.ac = ac;
    }
        
    @Override
    public void run() 
    {
        int c = a + b;
        try {
            Thread.sleep(c * 1000);
            PrintWriter out = ac.getResponse().getWriter();
            out.println("<vysledok>" + c + "</vysledok>");
            ac.complete();
        } catch (Exception e) {}        
    }

    @Override
    public void onComplete(AsyncEvent event) throws IOException {
        PrintWriter out = ac.getResponse().getWriter();
            out.println("<vysledok>" + "111" + "</vysledok>");
            ac.complete();
    }

    @Override
    public void onTimeout(AsyncEvent event) throws IOException {
                        PrintWriter out = ac.getResponse().getWriter();
            out.println("<vysledok>" + "timeout" + "</vysledok>");
            ac.complete();
    }

    @Override
    public void onError(AsyncEvent event) throws IOException {
                PrintWriter out = ac.getResponse().getWriter();
            out.println("<vysledok>" + "err" + "</vysledok>");
            ac.complete();
    }

    @Override
    public void onStartAsync(AsyncEvent event) throws IOException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}


/**
 *
 * @author petrovic
 */
@WebServlet(name = "VypoctovyServlet", urlPatterns = {"/vypoctovyservlet"}, asyncSupported = true)
public class VypoctovyServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        AsyncContext ac = request.startAsync();
        response.setContentType("text/xml;charset=UTF-8");
        
        Vypocet v = new Vypocet(Integer.parseInt(request.getParameter("a")), 
                                Integer.parseInt(request.getParameter("b")),
                                ac);
        
        
        ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(10);
        executor.execute(v);  
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
